Package org.apache.sling.spi.resource.provider

# Interface QueryLanguageProvider<T>

@ConsumerType public interface QueryLanguageProvider<T>
The JCR query provider supports querying based on the JCR spec. Calls from `ResourceResolver.findResources(String, String)` and `ResourceResolver.queryResources(String, String)` are passed on to this object.

Since:
  1.0.0 (Sling API Bundle 2.11.0)

## Method Summary

Modifier and Type
Method
Description
`Iterator<Resource>`
`findResources(@NotNull ResolveContext<T> ctx, String query, String language)`
Searches for resources using the given query formulated in the given language.
`String[]`
`getSupportedLanguages(@NotNull ResolveContext<T> ctx)`
The supported languages of the resource provider.
`Iterator<ValueMap>`
`queryResources(@NotNull ResolveContext<T> ctx, String query, String language)`
Queries the storage using the given query formulated in the given language.

## Method Details

### getSupportedLanguages

String[] getSupportedLanguages(@NotNull @NotNull ResolveContext<T> ctx)
The supported languages of the resource provider.

Parameters:
  `ctx` - The resolve context
Returns:
  The array of supported languages

### findResources

Iterator<Resource> findResources(@NotNull @NotNull ResolveContext<T> ctx, String query, String language)
Searches for resources using the given query formulated in the given language.

The semantic meaning of the query and language depend on the actual implementation and storage used for the resources. For JCR repository being used as storage, the query and language parameters are used to create a JCR `Query` through the `QueryManager`. The result returned is then based on the `NodeIterator` provided by the query result.

Parameters:
  `ctx` - The resolve context
  `query` - The query string to use to find the resources.
  `language` - The language in which the query is formulated.
Returns:
  An `Iterator` of `Resource` objects matching the query. If no resources match, `null` might be returned instead of an empty iterator.
Throws:
  `QuerySyntaxException` - If the query is not syntactically correct according to the query language indicator or if the query language is not supported as specified in `getSupportedLanguages(ResolveContext)`.
  `SlingException` - If an error occurs querying for the resources.
  `IllegalStateException` - if this resource provider has already been closed.

### queryResources

Iterator<ValueMap> queryResources(@NotNull @NotNull ResolveContext<T> ctx, String query, String language)
Queries the storage using the given query formulated in the given language.

The semantic meaning of the query and language depend on the actual implementation and storage used for the resources. For JCR repository being used as storage, the query and language parameters are used to create a JCR `Query` through the `QueryManager`. The result returned is then based on the `RowIterator` provided by the query result. The map returned for each row is indexed by the column name and the column value is the JCR `Value` object converted into the respective Java object, such as `Boolean` for a value of property type Boolean.

Parameters:
  `ctx` - The resolve context
  `query` - The query string to use to find the resources.
  `language` - The language in which the query is formulated.
Returns:
  An `Iterator` of `Map` instances providing access to the query result. If no resources match, `null` might be returned instead of an empty iterator.
Throws:
  `QuerySyntaxException` - If the query is not syntactically correct according to the query language indicator or if the query language is not supported as specified in `getSupportedLanguages(ResolveContext)`.
  `SlingException` - If an error occurs querying for the resources.
  `IllegalStateException` - if this resource provider has already been closed.